' FFSubmenu=Tools
' FFName=Textlink

'FFSkriptName=Muster.vbs(.vbe)
'FFSkriptAuthor=Harald Maeckler
'FFSkriptVersion=1.01
'FFVersion=2.90.0
'FFSkriptURL=http://www.meckis-steckenpferde.de/FixFoto_Skripte.html

' ********************************************************************
' Textlink (Skript fr FixFoto)
' Funktion:	Text und Webadresse wandeln in einen Textlink in HTML-Code
'
' Copyright Harald Maeckler, Dsseldorf 2011 / 2012
'
'** Start Kurzbeschreibung *******************************************
' Textlink / Version 1.02
' ==============
'
' Man kann whlen zwischen 'Bild einfgen' und/oder 'Textlink' einfgen.
' Nach Eingabe der Parameter wird mit 'HTML-Code' erzeugen gem den Einstellungen ein
' HTML-Code generiert. Dieser wird angezeigt und nach Besttigung mit JA in die Zwischen-
' ablage bernommen.
'
' Bild einfgen
' ----------------
' Das einzufgende Bild muss bereits im Web abgelegt und dessen Grafikadresse bekannt sein.
' Diese Adresse ist einzutragen.
' Dem Bild kann auf Wunsch noch ein weiterfhrender Link zugeordnet werden.
' Vor und nach dem Bild kann ein Zeilenumbruch erzwungen werden.
'
' Textlink einfgen
' ---------------------
' Es kann ein frei whlbarer Text eingegeben und ihm eine Linkadresse zugordnet werden.
'
' Zur Textdarstellung kann die Gre des Text und der Schriftschnitt kursiv und/oder fett
' bestimmt werden.
'
' Allgemein
' ------------
' Damit die Links spter jeweils auf einer neuen Seite angezeigt werden, muss die Option
' 'Links ffnen neue Seite' aktiviert werden.
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen ange-
' boten, davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Dann werden
' nacheinander die Skriptdatei, die in der Registry dazugehrenden Daten und eventuelle
' Zusatzdateien gelscht. Abschlieend wird die FixFotoScript.ini bereinigt.
'
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit 
' allen Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'
'** Ende Kurzbeschreibung ********************************************
'
' Version 1.02 vom 15.04.2012	- auch relative Linkadressen sind zugelassen
'								- Linkablage im Zwischenspeicher gendert
' Version 1.01 vom 19.03.2011	- 'Bild einfgen' hinzu
'								- Option 'Links ffnen neue Seite'
' Version 1.00 vom 16.03.2011	- Betaversion
' ********************************************************************

'**Start Encode**

Option Explicit

Dim SkriptName
const Skript = "Textlink"								'Skriptname
const RegSchluessel = "FF_Textlink"						'Registryschlssel

Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch	'Kurzbeschreibung
const ForReading = 1, ForWriting = 2
Abbruch = false

Dim objFS,WshShell										'Objekte
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

Dim SkriptKill,Antwort,TempFile	 : SkriptKill = false	'Lschroutine

Dim flag_Bild,bild_Link,flag_BildLink,Link_imBild,B_vorher,B_nachher
const S_Groesse = "2/3/4/5/6/7/8"
Dim flag_Text,text_Text,text_Link
Dim D_Groesse,D_Kursiv,D_Fett
Dim Link_nS
Dim HTML_Code,Array,element

call main
Set objFS = nothing
Set WshShell = nothing
'-------------------------------------------------------------------------
Sub main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

'** Start Dialog Textlink **
FF_AddDialog "Textlink",160,170
FF_AddControl "Textlink","Textlink einfgen","GROUP",5,66,148,39
FF_AddControl "Textlink","Bild einfgen","GROUP",5,4,148,58
FF_AddControl "Textlink","flag_Bild","BOOL",135,3,8,8
FF_SetControlStyle "Textlink","flag_Bild",16384
FF_AddControl "Textlink","Bild","STATIC",9,14,12,10
FF_AddControl "Textlink","bild_Link","SLEDIT",24,14,125,10
FF_AddControl "Textlink","Zeilenumbruch:","STATIC",27,49,38,10
FF_AddControl "Textlink","B_vorher","BOOL",72,50,8,8
FF_AddControl "Textlink","vorher","STATIC",84,49,16,10
FF_AddControl "Textlink","B_nachher","BOOL",111,50,8,8
FF_AddControl "Textlink","nachher","STATIC",123,49,20,10
FF_AddControl "Textlink","Text","STATIC",9,78,12,10
FF_AddControl "Textlink","text_Text","SLEDIT",24,78,125,10
FF_AddControl "Textlink","Link","STATIC",9,90,12,10
FF_AddControl "Textlink","text_Link","SLEDIT",24,90,125,10
FF_AddControl "Textlink","Textdarstellung","GROUP",5,109,148,25
FF_AddControl "Textlink","Gre","STATIC",12,119,18,10
FF_AddControl "Textlink","D_Groesse","COMBO",29,119,18,10
FF_AddControl "Textlink","Kursiv","STATIC",62,119,16,10
FF_AddControl "Textlink","D_Kursiv","BOOL",85,120,8,8
FF_AddControl "Textlink","Fett","STATIC",109,119,12,10
FF_AddControl "Textlink","D_Fett","BOOL",127,120,8,8
FF_AddControl "Textlink","Link_nS","BOOL",60,139,8,8
FF_AddControl "Textlink","Links ffnen neue Seite","STATIC",72,138,64,10
FF_AddControl "Textlink","?","BUTTON",6,154,11,11
FF_AddControl "Textlink","Abbrechen","BUTTON",46,154,34,11
FF_AddControl "Textlink","HTML-Code erzeugen","BUTTON",93,154,60,11
FF_AddControl "Textlink","&delete","BUTTON",2,2,1,1
FF_AddControl "Textlink","Link im Bild","STATIC",9,26,28,10
FF_AddControl "Textlink","flag_BildLink","BOOL",10,37,8,8
FF_AddControl "Textlink","Link_imBild","SLEDIT",24,36,125,10
FF_AddControl "Textlink","flag_Text","BOOL",135,65,8,8
FF_SetControlStyle "Textlink","flag_Text",16384
FF_AddControl "Textlink","V 1.02","STATIC",22,155,20,10
FF_SetControlStyle "Textlink","V 1.02",1
'** End Dialog Textlink **

call RegistryLesen

Array = split(S_Groesse,"/")
for each element in Array
	FF_SetControl "Textlink","D_Groesse",element
next

FF_ActivateControl "Textlink","&delete"

do
	Abbruch = false
	
	Select Case FF_ShowDialog ("Textlink")
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "HTML-Code erzeugen"
		call Werte_Lesen
		call Kontrolle
		if not Abbruch then
			call HTML
			
			Antwort = msgbox(HTML_Code & vbNewLine & vbNewLine & _
							"Soll der HTML-Code in die Zwischenablage bernommen werden?",vbYesNoCancel + vbQuestion,"HTML-Code")

			if Antwort = vbYes then
				FF_TextToClipboard HTML_Code
				exit do
			elseif Antwort = vbCancel then
				exit do
			end if
		end if
	Case "?"
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	Case "CANCEL", "Abbrechen"
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Textlink")

if SkriptKill then	'ggf. Skript 'Ordner lschen' komplett entfernen
	call KillSkript
end if

End Sub
'-------------------------------------------------------------------------
Sub Werte_Lesen

'Bild
flag_Bild = FF_GetControl("Textlink","flag_Bild")
bild_Link = trim(FF_GetControl("Textlink","bild_Link"))
flag_BildLink = FF_GetControl("Textlink","flag_BildLink")
Link_imBild = trim(FF_GetControl("Textlink","Link_imBild"))
B_vorher = FF_GetControl("Textlink","B_vorher")
B_nachher = FF_GetControl("Textlink","B_nachher")

'Text
flag_Text = FF_GetControl("Textlink","flag_Text")
text_Text = trim(FF_GetControl("Textlink","text_Text"))
text_Link = trim(FF_GetControl("Textlink","text_Link"))
D_Groesse = FF_GetControl("Textlink","D_Groesse")
D_Kursiv = FF_GetControl("Textlink","D_Kursiv")
D_Fett = FF_GetControl("Textlink","D_Fett")

'Allgemein
Link_nS= FF_GetControl("Textlink","Link_nS")

End Sub
'-------------------------------------------------------------------------
Sub Kontrolle

'Bild und/oder Text
if flag_Bild = 0 and flag_Text = 0 then
	msgbox "Es muss 'Bild einfgen' und/oder 'Text einfgen' aktiviert sein!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if
	
'Bild
if flag_Bild = 1 then
	if bild_Link = "" then
		msgbox "Es wurde kein Bildlink eingegeben!",vbExclamation,"Abbruch"
		Abbruch = true
		exit sub
	end if
	if flag_BildLink = 1 then
		if Link_imBild = "" then
			msgbox "Es wurde kein 'Link im Bild' eingegeben!",vbExclamation,"Abbruch"
			Abbruch = true
			exit sub
		end if
	end if
end if

'Text
if flag_Text = 1 then
	if text_Text = "" then
		msgbox "Es wurde kein Text eingegeben!",vbExclamation,"Abbruch"
		Abbruch = true
		exit sub
	end if
	if text_Link = "" then
		msgbox "Es wurde kein Textlink eingegeben!",vbExclamation,"Abbruch"
		Abbruch = true
		exit sub
	end if
end if

End Sub
'-------------------------------------------------------------------------
Sub HTML
Dim HTML_B,HTML_T

'Bildlink
if flag_Bild = 1 then
	if B_vorher = 1 then HTML_B = "<br>"
	if flag_BildLink = 1 then
		HTML_B = HTML_B & "<a"
		if Link_nS = 1 then HTML_B = HTML_B & " target=_blank"
		HTML_B = HTML_B & " href=" & """" & Link_imBild & """" & " >"
	end if
	HTML_B = HTML_B & "<IMG SRC=" & """" & bild_Link & """" & "><br>"
	if flag_BildLink = 1 then HTML_B = HTML_B & "</a>"
	if B_Nachher = 1 then HTML_B = HTML_B & "<br>"
end if

'Textlink
if flag_Text = 1 then
	if D_Fett = 1 then HTML_T = "<b>"
	if D_Kursiv = 1 then HTML_T = HTML_T & "<i>"
	HTML_T = HTML_T & "<font size= " & D_Groesse & ">" & "<a"
	if Link_nS = 1 then HTML_T = HTML_T & " target=_blank"
	HTML_T = HTML_T &  " href=" & """" & text_Link & """" & " >" & text_Text & "</a>"
	if D_Kursiv = 1 then HTML_T = HTML_T & "</i>"
	if D_Fett = 1 then HTML_T = HTML_T & "</b>"
end if

HTML_Code = HTML_B & HTML_T

End Sub
'-------------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim TBreite	: TBreite = LaengeMax * 2.6 + 10
const THoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",TBreite,THoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,TBreite,THoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",TBreite/2-15,THoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

'Bildlink
flag_Bild = FF_GetProfile (RegSchluessel,"flag_Bild")
if flag_Bild = "" then flag_Bild = 0
bild_Link = FF_GetProfile (RegSchluessel,"bild_Link")
flag_BildLink = FF_GetProfile (RegSchluessel,"flag_BildLink")
if flag_BildLink = "" then flag_BildLink = 0
Link_imBild = FF_GetProfile (RegSchluessel,"Link_imBild")
B_vorher = FF_GetProfile (RegSchluessel,"B_vorher")
if B_vorher = "" then B_vorher = 0
B_nachher = FF_GetProfile (RegSchluessel,"B_nachher")
if B_nachher = "" then B_nachher = 0

'Text und Link
flag_Text = FF_GetProfile (RegSchluessel,"flag_Text")
if flag_Text = "" then flag_Text = 0
text_Text = FF_GetProfile (RegSchluessel,"text_Text")
text_Link = FF_GetProfile (RegSchluessel,"text_Link")

'Darstellungsflags
D_Groesse = FF_GetProfile (RegSchluessel,"D_Groesse")
if D_Groesse = "" then D_Groesse = "3"
D_Kursiv = FF_GetProfile (RegSchluessel,"D_Kursiv")
if D_Kursiv = "" then D_Kursiv = 0
D_Fett = FF_GetProfile (RegSchluessel,"D_Fett")
if D_Fett = "" then D_Fett = 0

'Allgemein
Link_nS = FF_GetProfile (RegSchluessel,"Link_nS")
if Link_nS = "" then Link_nS = 0

'### Werte eintragen
FF_SetControl "Textlink","flag_Bild",flag_Bild
FF_SetControl "Textlink","bild_Link",bild_Link
FF_SetControl "Textlink","flag_BildLink",flag_BildLink
FF_SetControl "Textlink","Link_imBild",Link_imBild
FF_SetControl "Textlink","B_vorher",B_vorher
FF_SetControl "Textlink","B_nachher",B_nachher

FF_SetControl "Textlink","flag_Text",flag_Text
FF_SetControl "Textlink","text_Text",text_Text
FF_SetControl "Textlink","text_Link",text_Link
FF_SetControl "Textlink","D_Groesse",D_Groesse
FF_SetControl "Textlink","D_Kursiv",D_Kursiv
FF_SetControl "Textlink","D_Fett",D_Fett

FF_SetControl "Textlink","Link_nS",Link_nS

End Sub
'---------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call Werte_Lesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"flag_Bild",flag_Bild
FF_WriteProfile RegSchluessel,"bild_Link",bild_Link
FF_WriteProfile RegSchluessel,"flag_BildLink",flag_BildLink
FF_WriteProfile RegSchluessel,"Link_imBild",Link_imBild
FF_WriteProfile RegSchluessel,"B_vorher",B_vorher
FF_WriteProfile RegSchluessel,"B_nachher",B_nachher

FF_WriteProfile RegSchluessel,"flag_Text",flag_Text
FF_WriteProfile RegSchluessel,"text_Text",text_Text
FF_WriteProfile RegSchluessel,"text_Link",text_Link
FF_WriteProfile RegSchluessel,"D_Groesse",D_Groesse
FF_WriteProfile RegSchluessel,"D_Kursiv",D_Kursiv
FF_WriteProfile RegSchluessel,"D_Fett",D_Fett

FF_WriteProfile RegSchluessel,"Link_nS",Link_nS

End Sub
'---------------------------------------------------------------------
